package com.zcxk.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.zcxk.dto.AlarmDetailsDto;
import com.zcxk.dto.AlarmDetailsHistoryDto;
import com.zcxk.dto.AlarmDetailsRealTimeDto;
import com.zcxk.entity.AlarmDetailsEntity;

import java.util.List;

/**
 * @description
 * @auto wangli
 * @data 2020-11-17 15:43
 */
public interface AlarmDetailsService {

    /**
     * 查询单个设备
     * @return
     */
    AlarmDetailsDto selectById(Integer id);

    /**
     * 查询单个设备
     * @return
     */
    List<AlarmDetailsDto> selectByDeviceId(Long sceneId,Integer deviceId);
    /**
     * 查询单个设备属性
     * @return
     */
    List<AlarmDetailsDto> selectByDeviceAttributeId(Long sceneId,Integer deviceId,Integer attributeId);

    /**
     * 按场景查询
     * @return
     */
    List<AlarmDetailsDto> selectBySceneId(Integer sceneId);
    /**
     * 查询设备
     * @return
     */
    List<AlarmDetailsRealTimeDto> selectRealTimeByIds(List<Integer> ids);

    List<AlarmDetailsHistoryDto> selectHistoryByIds(List<Integer> ids);
    /**
     * 添加设备
     * @return
     */
    Integer insert(AlarmDetailsEntity alarmDetailsEntity);

    /**
     * 批量插入设备信息
     * @param alarmDetails
     * @return
     */
    Integer batchInsert(List<AlarmDetailsEntity> alarmDetails);

    /**
     * 单条删除设备
     * @return
     */
    Integer deleteById(Integer id);

    /**
     * 批量删除
     * @return
     */
    Integer batchDelete(List<Integer> ids);

    /**
     * 挂起/恢复
     * @return
     */
    Integer suspendedById(Integer id , Integer opState);

    /**
     * 修改设备信息
     * @return
     */
    Integer update(AlarmDetailsEntity alarmDetailsEntity);

    /**
     * 查询设备信息
     * @return
     */
    List<AlarmDetailsDto> selectList(AlarmDetailsDto alarmDetailsDto);

    /**
     * 分页查询
     * @return
     */
    IPage<AlarmDetailsDto> selectPage(IPage<AlarmDetailsDto> page, AlarmDetailsDto alarmDetailsDto);
    /**
     * 查询设备信息
     * @return
     */
    List<AlarmDetailsHistoryDto> selectHistoryList(AlarmDetailsDto alarmDetailsDto);

    /**
     * 查询设备信息
     * @return
     */
    List<AlarmDetailsRealTimeDto> selectRealTimeList(AlarmDetailsDto alarmDetailsDto);

    /**
     * 分页查询
     * @return
     */
    IPage<AlarmDetailsRealTimeDto> selectRealTimePage(IPage<AlarmDetailsRealTimeDto> page, AlarmDetailsDto alarmDetailsDto);


    /**
     * 分页查询
     * @return
     */
    IPage<AlarmDetailsHistoryDto> selectHistoryPage(IPage<AlarmDetailsHistoryDto> page, AlarmDetailsDto alarmDetailsDto);

    /**
     * 验证设备离线状态
     */
    void checkStateAlarm();

    /**
     * 报警信息生成工单信息
     */
    void saveWorkOrderManageInfo();
}
